QT       += core gui

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

CONFIG += c++11

# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0
unix{                           # ADDED BY L.Mewes 28.09.2021
DEFINES += __LINUX_ALSA__       # Defines the Midi-API that RtMidi will use. For Linux (also Raspbian) it will be ALSA
LIBS += -lasound                # Includes Sound and Threading-Libraries
LIBS += -lpthread               #
}
win32{                          # ADDED BY L.MEWES 09.10.2021
DEFINES += __WINDOWS_MM__       # Defines the Midi-APi that RtMidi will use. For Microsoft (R) Windows (TM) it will be "Windows-MM", only for test reasons
LIBS += -lwinmm                 # Includes multimedia-library
}

SOURCES += \
    CircleElement.cpp \
    CircleOfFifths.cpp \
    ColorScale.cpp \
    MainWindow.cpp \
    MidiListener.cpp \
    MidiProbe.cpp \
    PianoKey.cpp \
    PianoKeyBoard.cpp \
    RtMidi.cpp \
    Tone.cpp \
    main.cpp

HEADERS += \
    CircleElement.h \
    CircleOfFifths.h \
    ColorScale.h \
    MainWindow.h \
    MidiListener.h \
    MidiProbe.h \
    PianoKey.h \
    PianoKeyBoard.h \
    RtMidi.h \
    Tone.h

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target
